## ros-melodic-jsk-recognition-utils 1.2.15

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(jsk_recognition_utils)

# Use ccache if installed to make it fast to generate object files
find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(CCACHE_FOUND)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  dynamic_reconfigure
  jsk_recognition_msgs
  pcl_ros
  pcl_msgs
  eigen_conversions
  message_generation
  rostest
  tf_conversions
  tf
  tf2_ros
  image_geometry
  sensor_msgs
  geometry_msgs
  jsk_topic_tools
  visualization_msgs
)

catkin_python_setup()

generate_dynamic_reconfigure_options(
  cfg/PoseArrayToPose.cfg
  cfg/PolygonArrayToPolygon.cfg
)

catkin_package(
 INCLUDE_DIRS include
 LIBRARIES jsk_recognition_utils
 CATKIN_DEPENDS jsk_recognition_msgs pcl_ros visualization_msgs message_runtime
)

# Cythonize pyx files
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(UseCython)
add_subdirectory(python/${PROJECT_NAME})

find_package(OpenCV REQUIRED core imgproc)
find_package(PCL REQUIRED)
find_package(PkgConfig)
pkg_check_modules(yaml_cpp yaml-cpp REQUIRED)
IF(${yaml_cpp_VERSION} VERSION_LESS "0.5.0")
## indigo yaml-cpp : 0.5.0 /  hydro yaml-cpp : 0.3.0
  add_definitions("-DUSE_OLD_YAML")
ENDIF()
if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -z defs")
endif()
include_directories(
  include ${catkin_INCLUDE_DIRS}
)
link_libraries(${catkin_LIBRARIES} ${OpenCV_LIBRARIES} ${PCL_LIBRARIES} yaml-cpp)

add_library(jsk_recognition_utils SHARED
  src/grid_index.cpp
  src/grid_map.cpp
  src/grid_line.cpp
  src/geo_util.cpp
  src/random_util.cpp
  src/pcl_ros_util.cpp
  src/pcl_conversion_util.cpp
  src/pcl_util.cpp
  src/tf_listener_singleton.cpp
  src/pcl/ear_clipping_patched.cpp
  src/sensor_model_utils.cpp
  src/cv_utils.cpp
  src/rgb_colors.cpp
  src/geo/line.cpp
  src/geo/segment.cpp
  src/geo/polyline.cpp
  src/geo/plane.cpp
  src/geo/polygon.cpp
  src/geo/convex_polygon.cpp
  src/geo/cube.cpp
  src/geo/cylinder.cpp
  src/geo/grid_plane.cpp
  src/time_util.cpp
  )

if (CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  if("$ENV{ROS_DISTRO}" STRGREATER "indigo") # kinetic and later uses qt5
    find_package(Qt5Widgets REQUIRED)
    set(QT_LIBRARIES Qt5::Widgets)
  endif()
  add_rostest_gtest(test_tf_listener_singleton test/tf_listener_singleton.test src/tests/test_tf_listener_singleton.cpp)
  target_link_libraries(test_tf_listener_singleton ${PROJECT_NAME} ${catkin_LIBRARIES})
  catkin_add_gtest(test_cv_utils src/tests/test_cv_utils.cpp)
  target_link_libraries(test_cv_utils ${PROJECT_NAME} ${OpenCV_LIBRARIES})
  catkin_add_gtest(test_rgb_colors src/tests/test_rgb_colors.cpp)
  target_link_libraries(test_rgb_colors ${PROJECT_NAME} ${OpenCV_LIBRARIES})
  if("$ENV{ROS_DISTRO}" STRGREATER "hydro")
    # FIXME: jsk_tools/test_topic_published.py does not work on hydro travis/jenkins
    # https://github.com/jsk-ros-pkg/jsk_common/pull/1293#issuecomment-164158260
    add_rostest(sample/sample_add_bounding_box_array.launch ARGS gui:=false)
    add_rostest(sample/sample_bounding_box_array_publisher.launch ARGS gui:=false)
    add_rostest(test/add_cluster_indices.test)
    add_rostest(test/image_16uc1_to_32fc1.test)
    add_rostest(test/polygon_array_publisher.test)
    add_rostest(test/polygon_array_to_polygon.test)
    add_rostest(test/pose_array_to_pose.test)
    add_rostest(test/rect_array_to_polygon_array.test)
    add_rostest(test/static_virtual_camera.test)
  endif()
endif()

# From https://github.com/jsk-ros-pkg/jsk_recognition/pull/2345
# Install header files directly into ${CATKIN_PACKAGE_INCLUDE_DESTINATION}.
# If the package has setup.py and modules under src/${PROJECT_NAME}/,
# install python executables directly into ${CATKIN_PACKAGE_BIN_DESTINATION}.
# However, if it doesn't have setup.py, directories including python executables
# should be installed recursively into ${CATKIN_PACKAGE_SHARE_DESTINATION}.
# Also, other directories like 'launch' or 'sample' must be installed
# recursively into ${CATKIN_PACKAGE_SHARE_DESTINATION}.
# Be careful that 'launch' and 'launch/' are different: the former is directory
# and the latter is each content.
install(TARGETS jsk_recognition_utils
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(DIRECTORY node_scripts sample test
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
  USE_SOURCE_PERMISSIONS
)

=== python/jsk_recognition_utils/CMakeLists.txt ===
if(NOT DEFINED Numpy_INCLUDE_DIRS)
  # Get Numpy include directories
  execute_process(
    COMMAND python$ENV{ROS_PYTHON_VERSION} -c "import sys, numpy; sys.stdout.write(numpy.get_include())"
    OUTPUT_VARIABLE Numpy_INCLUDE_DIRS
    RESULT_VARIABLE retcode)
  if(NOT ${retcode} EQUAL 0)
    message(FATAL_ERROR "Failed to get Numpy include dirs by numpy.get_include(). Exit code: ${retcode}")
  endif()
endif()
# Compile nms.pyx
include_directories(${Numpy_INCLUDE_DIRS})
cython_add_module(nms nms.pyx)
set_target_properties(nms PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_PYTHON_DESTINATION})
cython_add_module(color color.pyx)
set_target_properties(color PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_PYTHON_DESTINATION})
install(TARGETS nms color
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_PYTHON_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_PYTHON_DESTINATION}
)

=== debian/changelog ===
ros-melodic-jsk-recognition-utils (1.2.15-1stretch) stretch; urgency=high



 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Sat, 10 Oct 2020 00:00:00 -0000

ros-melodic-jsk-recognition-utils (1.2.14-1stretch) stretch; urgency=high



 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Fri, 09 Oct 2020 00:00:00 -0000

ros-melodic-jsk-recognition-utils (1.2.13-1stretch) stretch; urgency=high



 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Thu, 08 Oct 2020 00:00:00 -0000

ros-melodic-jsk-recognition-utils (1.2.12-1stretch) stretch; urgency=high



 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Sat, 03 Oct 2020 00:00:00 -0000

ros-melodic-jsk-recognition-utils (1.2.11-1stretch) stretch; urgency=high

  * Add ssd to bounding box sample (#2513 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2513>)
    
      * rename launch and rvizconfig
      * rename to sample_table_rects_to_bounding_box.launch
      * update rviz config
      * refactor launch files
      * add ssd output arg
      * enabe to put out the bounding box
      * try to make ssd to bbox sample
    
  * Include cython3 when searching (#2531 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2531>)
  * [jsk_recognition_utils] add rect_array_to_cluster_point_indices.py (#2511 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2511>)
  * [jsk_recognition_utils] remove unnecessary dynamic_reconfigure in rect_array_to_polygon_array.py (#2510 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2510>)
    
      * fix typo in rect_array_to_cluster_point_indices.py
      * add test and sample for rect_array_to_cluster_point_indices
      * add rect_array_to_cluster_point_indices.py
      * remove unused dynamic_reconfigure in rect_array_to_polygon_array.py
    
  * Add FCN8sDepthPredictionConcatFirst model to fcn_depth_prediction.py (#2481 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2481>)
    
      * Remove unused import in depth_prediction dataset
      * Rewrite data augmentation to remove dependency on imgaug
      * Read dataset directory from argument
      * Add loss computation
      * Add weight initialization from VGG16
      * Flatten images for network input
      * Rewrite mvtk-dependent code
      * Remove redundant visualization of DepthPredictionDataset
      * Rosdep install imgaug
      * Fix default root_dir of DepthPredictionDataset
      * Move FCN8sDepthPrediction chainer models to jsk_recognition_utils
      * Add DepthPredictionDataset
    
  * Fix for  noetic / 20.04 (#2507 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2507>)
    
      * jsk_recognition_utils/cv_utils.h fix for opencv4
      * upgrade package.xml to format=3, migrate to noetic with ROS_PYTHON_VERSION=2/3, use multiple ROS distro strategy http://wiki.ros.org/noetic/Migration
    
  * [jsk_perception] add program for training ssd with box annotation (#2483 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2483>)
  * set chainer version less than 7.0.0 (#2485 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2485>)
  * [jsk_recognition_utils] Fix ear clipping triangulation to support concave polygon (#2447 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2447>)
    
      * Handle parallel line segments as well
      * Check if line segment 'uw' completely lies inside the polygon for correcting isEar function
      * Rename func: triangulate -> triangulateClockwiseVertices
      * Add space in 'if' line for readable code
      * Fix ear clipping to support concave polygon
    
  * Add train script and sample for SSD (#2471 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2471>)
  * fix generate_readme.py and update readme (#2442 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2442>)
  * Add sample, test and doc (#2440 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2440>)
    
      * Add dependency on image_view in jsk_recognition_utils/package.xml
      * Add test for image_16uc1_to_32fc1.py
      * Add sample for image_16uc1_to_32fc1.py
      * Add test for rect_array_to_polygon_array.py
      * Add sample for rect_array_to_polygon_array.py
      * Fix output polygon vertices in rect_array_to_polygon_array.py
      * Add test for add_cluster_indices.py
      * Add sample for add_cluster_indices.py
      * Add test for static_virtual_camera.py
      * Add test for pose_array_to_pose.py
      * Add sample for pose_array_to_pose.py
      * Add test for polygon_array_to_polygon
      * Add sample for polygon_array_to_polygon
      * Add test for polygon_array_publisher
      * Fix rviz config for sample_polygon_array_publisher.launch
      * add label to bounding_box_publisher.py
    
  * [jsk_recognition_utils] Add label to bounding_box_publisher.py (#2430 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2430>)
  * Contributors: Naoaki Kanazawa, Kei Okada, Peter Mitrano, Shingo Kitagawa, Yuki Furuta, Yuto Uchimi, Taichi Higashide

 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Thu, 01 Oct 2020 00:00:00 -0000

ros-melodic-jsk-recognition-utils (1.2.10-1stretch) stretch; urgency=high

  * Add qtbase5-dev as a package.xml dependency for jsk_recognition_utils. (#2417 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2417>)
    Needed since CMakeLists.txt tries to depend on it.
    Signed-off-by: Chris Lalancette <mailto:clalancette@openrobotics.org>
  * Contributors: Chris Lalancette

 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Wed, 27 Mar 2019 00:00:00 -0000

ros-melodic-jsk-recognition-utils (1.2.9-1stretch) stretch; urgency=high

  * add QT_LIBRARIES Qt5::Widgets to fix 'cannot find -lQt5::Widgets' error on debian stretch (#2398 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2398> )
  * Contributors: Kei Okada

 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Sat, 23 Feb 2019 00:00:00 -0000

ros-melodic-jsk-recognition-utils (1.2.8-1stretch) stretch; urgency=high



 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Fri, 22 Feb 2019 00:00:00 -0000



=== debian/control ===
Source: ros-melodic-jsk-recognition-utils
Section: misc
Priority: optional
Maintainer: Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>
Build-Depends: debhelper (>= 9.0.0), cython, libyaml-cpp-dev, python-setuptools, qtbase5-dev, ros-melodic-catkin, ros-melodic-dynamic-reconfigure, ros-melodic-eigen-conversions, ros-melodic-geometry-msgs, ros-melodic-image-geometry, ros-melodic-jsk-recognition-msgs, ros-melodic-jsk-tools, ros-melodic-jsk-topic-tools, ros-melodic-message-generation, ros-melodic-pcl-msgs, ros-melodic-pcl-ros, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-tf, ros-melodic-tf-conversions, ros-melodic-tf2-ros, ros-melodic-visualization-msgs
Homepage: https://jsk-docs.readthedocs.io/projects/jsk_recognition/en/latest/jsk_recognition_utils
Standards-Version: 3.9.2

Package: ros-melodic-jsk-recognition-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libyaml-cpp-dev, python-skimage, ros-melodic-eigen-conversions, ros-melodic-geometry-msgs, ros-melodic-image-geometry, ros-melodic-image-view, ros-melodic-jsk-recognition-msgs, ros-melodic-jsk-topic-tools, ros-melodic-message-runtime, ros-melodic-pcl-msgs, ros-melodic-pcl-ros, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-tf, ros-melodic-tf-conversions, ros-melodic-tf2-ros, ros-melodic-visualization-msgs
Description: C++ library about sensor model, geometrical modeling and perception.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-jsk-recognition-utils//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
